create table CUSTOMER
(
    ID           UUID DEFAULT RANDOM_UUID() NOT NULL PRIMARY KEY,
    NAME         VARCHAR2(50)               not null,
    EMAIL        VARCHAR2(50)               not null,
    PHONE_NUMBER NUMBER
);

create table ADDRESS
(
    ID          UUID DEFAULT RANDOM_UUID() NOT NULL PRIMARY KEY,
    ADDRESS     VARCHAR2(100),
    CITY        VARCHAR2(50),
    POSTAL_CODE VARCHAR2(100),
    CUSTOMER_ID RAW(16)
);

create table "ORDER"
(
    ID            UUID DEFAULT RANDOM_UUID() NOT NULL PRIMARY KEY,
    ORDER_DETAILS VARCHAR2(100),
    CUSTOMER_ID   RAW(16)
);

create table PRODUCT
(
    ID           UUID DEFAULT RANDOM_UUID() NOT NULL PRIMARY KEY,
    PRODUCT_NAME VARCHAR2(50),
    PRICE        number,
    DESCRIPTION  VARCHAR2(50),
    SUPPLIER_ID  RAW(16),
    ORDER_ID     RAW(16),
    PRODUCT_TYPE VARCHAR2(50)
);

create table SUPPLIER
(
    ID                UUID DEFAULT RANDOM_UUID() NOT NULL PRIMARY KEY,
    NAME              VARCHAR2(50),
    POSTAL_CODE       VARCHAR2(56),
    ADDRESS           VARCHAR2(256),
    PRODUCTS_SUPPLIER VARCHAR2(50)
);

create table WAREHOUSE
(
    ID          UUID DEFAULT RANDOM_UUID() NOT NULL PRIMARY KEY,
    ADDRESS     VARCHAR2(100),
    CITY        VARCHAR2(50),
    SUPPLIER_ID RAW(16)
);

ALTER TABLE "ORDER"
    ADD CONSTRAINT CUSTOMER_FK FOREIGN KEY (CUSTOMER_ID) REFERENCES CUSTOMER (ID);

ALTER TABLE "PRODUCT"
    ADD CONSTRAINT ORDER_FK FOREIGN KEY (ORDER_ID) REFERENCES "ORDER" (ID);

ALTER TABLE PRODUCT
    ADD CONSTRAINT SUPPLIER_ID FOREIGN KEY (SUPPLIER_ID) REFERENCES SUPPLIER (ID);

ALTER TABLE WAREHOUSE
    ADD CONSTRAINT SUPPLIER_FK FOREIGN KEY (SUPPLIER_ID) REFERENCES SUPPLIER (ID);

ALTER TABLE ADDRESS
    ADD CONSTRAINT CUSTOMER_ADDRESS_FK FOREIGN KEY (CUSTOMER_ID) REFERENCES CUSTOMER (ID);